<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: util/cart2sphere.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_81f17f03227d7067ce13f3651b0bf66b.html">util</a>
  </div>
</div>
<div class="contents">
<h1>cart2sphere.c</h1><a href="cart2sphere_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: cart2sphere.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a><a class="code" href="util_8h.html#a2f8d6af80c328b771a233e4912be1835">00029</a> <span class="keywordtype">int</span> <a class="code" href="cart2sphere_8c.html#a2f8d6af80c328b771a233e4912be1835">Sphere2Cart</a>(Vec S, Vec C)
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00032"></a>00032 
<a name="l00033"></a>00033   <span class="keywordtype">int</span> t_Clen,t_Slen;
<a name="l00034"></a>00034   ierr = VecGetLocalSize(S,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;t_Slen);CHKERRQ(ierr);
<a name="l00035"></a>00035   ierr = VecGetLocalSize(C,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;t_Clen);CHKERRQ(ierr);
<a name="l00036"></a>00036   assert(t_Clen%<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>==0);
<a name="l00037"></a>00037   assert(t_Clen*(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>-1)/<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>==t_Slen);
<a name="l00038"></a>00038 
<a name="l00039"></a>00039   PetscReal *ta_C,*ta_S;
<a name="l00040"></a>00040   ierr = VecGetArray(S,&amp;ta_S);CHKERRQ(ierr);
<a name="l00041"></a>00041   ierr = VecGetArray(C,&amp;ta_C);CHKERRQ(ierr);
<a name="l00042"></a>00042 
<a name="l00043"></a>00043   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;t_Clen/<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;i++) {
<a name="l00044"></a>00044     <span class="comment">/* x=sin(theta)*cos(phi) */</span>
<a name="l00045"></a>00045     ta_C[i*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>+0]=sin(ta_S[(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>-1)*i+0])*cos(ta_S[(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>-1)*i+1]);
<a name="l00046"></a>00046     <span class="comment">/* y=sin(theta)*sin(phi) */</span>
<a name="l00047"></a>00047     ta_C[i*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>+1]=sin(ta_S[(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>-1)*i+0])*sin(ta_S[(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>-1)*i+1]);
<a name="l00048"></a>00048     <span class="comment">/* y=cos(theta) */</span>
<a name="l00049"></a>00049     ta_C[i*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>+2]=cos(ta_S[(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>-1)*i+0]);
<a name="l00050"></a>00050   }
<a name="l00051"></a>00051 
<a name="l00052"></a>00052   ierr = VecRestoreArray(C,&amp;ta_C);CHKERRQ(ierr);
<a name="l00053"></a>00053   ierr = VecRestoreArray(S,&amp;ta_S);CHKERRQ(ierr);
<a name="l00054"></a>00054 
<a name="l00055"></a>00055   <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00056"></a>00056 }
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 
<a name="l00059"></a><a class="code" href="util_8h.html#a519926eb0e8844daa1219a94521b9882">00059</a> <span class="keywordtype">int</span> <a class="code" href="cart2sphere_8c.html#a519926eb0e8844daa1219a94521b9882">Cart2Sphere</a>(Vec C, Vec S)
<a name="l00060"></a>00060 {
<a name="l00061"></a>00061   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   <span class="keywordtype">int</span> t_Clen,t_Slen;
<a name="l00064"></a>00064   ierr = VecGetLocalSize(S,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;t_Slen);CHKERRQ(ierr);
<a name="l00065"></a>00065   ierr = VecGetLocalSize(C,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;t_Clen);CHKERRQ(ierr);
<a name="l00066"></a>00066   assert(t_Clen%<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>==0);
<a name="l00067"></a>00067   assert(t_Clen*(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>-1)/<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>==t_Slen);
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   PetscReal *ta_C,*ta_S;
<a name="l00070"></a>00070   ierr = VecGetArray(S,&amp;ta_S);CHKERRQ(ierr);
<a name="l00071"></a>00071   ierr = VecGetArray(C,&amp;ta_C);CHKERRQ(ierr);
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;t_Clen/<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;i++) {
<a name="l00074"></a>00074     <span class="comment">/* theta=acos(z) */</span>
<a name="l00075"></a>00075     ta_S[2*i+0]=acos(ta_C[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+2]);
<a name="l00076"></a>00076     <span class="comment">/* phi=atan(y/x) */</span>
<a name="l00077"></a>00077     ta_S[2*i+1]=atan2(ta_C[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+1],ta_C[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+0]);
<a name="l00078"></a>00078 
<a name="l00079"></a>00079     <span class="comment">/* map negative values [-Pi,0] to [Pi,2*Pi] */</span>
<a name="l00080"></a>00080 <span class="comment">/*</span>
<a name="l00081"></a>00081 <span class="comment">    if (ta_C[ND*i+0]&lt;0) ta_S[2*i+1] = 2.0*PETSC_PI+ta_S[2*i+1];</span>
<a name="l00082"></a>00082 <span class="comment">*/</span>
<a name="l00083"></a>00083   }
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   ierr = VecRestoreArray(C,&amp;ta_C);CHKERRQ(ierr);
<a name="l00086"></a>00086   ierr = VecRestoreArray(S,&amp;ta_S);CHKERRQ(ierr);
<a name="l00087"></a>00087 
<a name="l00088"></a>00088   <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00089"></a>00089 }
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 
<a name="l00092"></a><a class="code" href="util_8h.html#aac1a7d4f53770aebf3759a36a9d384b6">00092</a> <span class="keywordtype">int</span> <a class="code" href="cart2sphere_8c.html#aac1a7d4f53770aebf3759a36a9d384b6">Cart2SphereDiff</a>(Vec C, Vec X, Vec S)
<a name="l00093"></a>00093 {
<a name="l00094"></a>00094   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   <span class="keywordtype">int</span> t_Clen,t_Xlen,t_Slen;
<a name="l00097"></a>00097   ierr = VecGetLocalSize(C,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;t_Clen);CHKERRQ(ierr);
<a name="l00098"></a>00098   ierr = VecGetLocalSize(X,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;t_Xlen);CHKERRQ(ierr);
<a name="l00099"></a>00099   ierr = VecGetLocalSize(S,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;t_Slen);CHKERRQ(ierr);
<a name="l00100"></a>00100   assert(t_Clen%<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>==0);
<a name="l00101"></a>00101   assert(t_Clen*(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>-1)/<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>==t_Xlen);
<a name="l00102"></a>00102   assert(t_Clen*(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>-1)/<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>==t_Slen);
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   PetscReal *ta_C,*ta_X,*ta_S;
<a name="l00105"></a>00105   ierr = VecGetArray(C,&amp;ta_C);CHKERRQ(ierr);
<a name="l00106"></a>00106   ierr = VecGetArray(X,&amp;ta_X);CHKERRQ(ierr);
<a name="l00107"></a>00107   ierr = VecGetArray(S,&amp;ta_S);CHKERRQ(ierr);
<a name="l00108"></a>00108 
<a name="l00109"></a>00109   <span class="comment">/* cf. http://mathworld.wolfram.com/SphericalCoordinates.html */</span>
<a name="l00110"></a>00110   <span class="comment">/* http://chsfpc5.chem.ncsu.edu/~franzen/CH795Z/math/ang_mom_op/ang_mom_op.html */</span>
<a name="l00111"></a>00111   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;t_Clen/<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;i++) {
<a name="l00112"></a>00112     ta_S[(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>-1)*i+0]=
<a name="l00113"></a>00113        ta_C[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+0]*cos(ta_X[(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>-1)*i+0])*cos(ta_X[(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>-1)*i+1])
<a name="l00114"></a>00114       +ta_C[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+1]*cos(ta_X[(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>-1)*i+0])*sin(ta_X[(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>-1)*i+1])
<a name="l00115"></a>00115       -ta_C[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+2]*sin(ta_X[(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>-1)*i+0]);
<a name="l00116"></a>00116 
<a name="l00117"></a>00117     ta_S[(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>-1)*i+1]=
<a name="l00118"></a>00118       -ta_C[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+0]*sin(ta_X[(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>-1)*i+0])*sin(ta_X[(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>-1)*i+1])
<a name="l00119"></a>00119       +ta_C[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+1]*sin(ta_X[(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>-1)*i+0])*cos(ta_X[(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>-1)*i+1]);
<a name="l00120"></a>00120   }
<a name="l00121"></a>00121 
<a name="l00122"></a>00122   ierr = VecRestoreArray(C,&amp;ta_C);CHKERRQ(ierr);
<a name="l00123"></a>00123   ierr = VecRestoreArray(X,&amp;ta_X);CHKERRQ(ierr);
<a name="l00124"></a>00124   ierr = VecRestoreArray(S,&amp;ta_S);CHKERRQ(ierr);
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00127"></a>00127 }
<a name="l00128"></a>00128 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

